// Gear5.java
// Button control, remote mode

import ch.aplu.raspi.*;

public class Gear5
{
  private Gear gear = new Gear();
  int v = 0;
  int vInc = 10;
  double dir = 0;
  double dirInc = 5;

  public Gear5()
  {
    Robot robot = new Robot();
    while (!robot.isEscapeHit())
    {
      if (robot.isEnterHit())
      {
        System.out.println("enter hit");
        v = 0;
        dir = 0;
        doIt();
      }
      else if (robot.isUpHit())
      {
        System.out.println("up hit");
        v = v += vInc;
        doIt();
      }
      else if (robot.isDownHit())
      {
        System.out.println("down hit");
        v = v -= vInc;
        doIt();
      }
      else if (robot.isRightHit())
      {
        System.out.println("right hit");
        if (dir < 80)
        {
          dir += dirInc;
          doIt();
        }
      }
      else if (robot.isLeftHit())
      {
        System.out.println("left hit");
        if (dir > -80)
        {
          dir -= dirInc;
          doIt();
        }
      }
      else
        Tools.delay(100);
    }
    System.out.println("All done");
    robot.exit();
  }

  private void doIt()
  {
    double radius = toRadius(dir);
    System.out.println("doIt with v = " + v + ", dir = " + dir
      + ", radius = " + radius);
    gear.setSpeed(Math.abs(v));
    if (v > 0)
    {
      if (dir > 0)
        gear.rightArc(radius);
      else if (dir < 0)
        gear.leftArc(radius);
      else
        gear.forward();
    }
    else if (v < 0)
    {
      if (dir > 0)
        gear.leftArc(-radius);
      else if (dir < 0)
        gear.rightArc(-radius);
      else
        gear.backward();
    }
    else
      gear.stop();
  }

  private double toRadius(double direction)
  {
    double R = 0.05;
    if (direction != 0)
    {
      double r = Math.abs(R / Math.sin(Math.toRadians(direction)));
      return r;
    }
    return 0;
  }

  public static void main(String[] args)
  {
    new Gear5();
  }
}
