// Ultrasonic4a.java
// Event driven ultrasonic sensor

import ch.aplu.raspi.*;
import java.awt.Color;
import java.awt.Point;

public class Ultrasonic4a implements UltrasonicListener
{
  private Robot robot = new Robot();
  private Gear gear = new Gear();

  public Ultrasonic4a()
  {
    UltrasonicSensor us = new UltrasonicSensor();
    us.addUltrasonicListener(this);
    us.setBeamAreaColor(Color.green);
    us.setProximityCircleColor(Color.lightGray);
    gear.setSpeed(25);
    gear.forward();
    while (!robot.isEscapeHit())
       Tools.delay(100);
    robot.exit();
  }

  public void far(double value)
  {
  }

  public void near(double value)
  {
    gear.backward(2000);
    gear.left(1000);
    gear.forward();
  }

  public static void main(String[] args)
  {
    new Ultrasonic4a();
  }

  // ------------------ Environment --------------------------
  static
  {
    Point[] mesh_hbar =
    {
      new Point(200, 10), new Point(-200, 10),
      new Point(-200, -10), new Point(200, -10)
    };
    Point[] mesh_vbar =
    {
      new Point(10, 200), new Point(-10, 200),
      new Point(-10, -200), new Point(10, -200)
    };
    RobotContext.useTarget("sprites/bar0.gif", mesh_hbar, 250, 100);
    RobotContext.useTarget("sprites/bar0.gif", mesh_hbar, 250, 400);
    RobotContext.useTarget("sprites/bar1.gif", mesh_vbar, 100, 250);
    RobotContext.useTarget("sprites/bar1.gif", mesh_vbar, 400, 250);
  }

}
